#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_boxit import boxit
from taskinit import casalog
from taskinit import xmlpath
class boxit_pg_:
    __name__ = "boxit"

    def __init__(self) :
       self.__bases__ = (boxit_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, imagename=None,regionfile=None,threshold=None,maskname=None,chanrange=None,polrange=None,minsize=None,diag=None,boxstretch=None,overwrite=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'boxit'
        myf['taskname'] = 'boxit'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['imagename'] = imagename = myf['imagename']
            myparams['regionfile'] = regionfile = myf['regionfile']
            myparams['threshold'] = threshold = myf['threshold']
            myparams['maskname'] = maskname = myf['maskname']
            myparams['chanrange'] = chanrange = myf['chanrange']
            myparams['polrange'] = polrange = myf['polrange']
            myparams['minsize'] = minsize = myf['minsize']
            myparams['diag'] = diag = myf['diag']
            myparams['boxstretch'] = boxstretch = myf['boxstretch']
            myparams['overwrite'] = overwrite = myf['overwrite']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['regionfile'] = regionfile
        if type(threshold) == str :
           mytmp['threshold'] = casac.quanta().quantity(threshold)
        else :
           mytmp['threshold'] = threshold
        mytmp['maskname'] = maskname
        mytmp['chanrange'] = chanrange
        mytmp['polrange'] = polrange
        mytmp['minsize'] = minsize
        mytmp['diag'] = diag
        mytmp['boxstretch'] = boxstretch
        mytmp['overwrite'] = overwrite
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'boxit.xml')

        casalog.origin('boxit')
        if not trec.has_key('boxit') or not casac.utils().verify(mytmp, trec['boxit']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: boxit           #####')
          casalog.post('')
          result = boxit(imagename, regionfile, threshold, maskname, chanrange, polrange, minsize, diag, boxstretch, overwrite)
          casalog.post('')
          casalog.post('##### End Task: boxit           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('boxit', 'boxit.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'boxit'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('boxit', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['imagename']  = ''
        a['regionfile']  = ''
        a['threshold']  = '0.0mJy'
        a['maskname']  = ''
        a['chanrange']  = ''
        a['polrange']  = ''
        a['minsize']  = 2
        a['diag']  = False
        a['boxstretch']  = 1
        a['overwrite']  = False


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['imagename']  = ''
        a['regionfile']  = ''
        a['threshold']  = '0.0mJy'
        a['maskname']  = ''
        a['chanrange']  = ''
        a['polrange']  = ''
        a['minsize']  = 2
        a['diag']  = False
        a['boxstretch']  = 1
        a['overwrite']  = False

        if a.has_key(paramname) :
	      return a[paramname]
boxit_pg = boxit_pg_()
