#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_imhistory
def imhistory(imagename='', mode='list', verbose=True, origin='imhistory', message=''):

        """Retrieve and modify image history
PARAMETER SUMMARY
imagename        Name of the input (CASA, FITS, MIRIAD) image
mode             Operating mode. Either "list" or "append" is accepted.
verbose          Log history if mode="list"?
origin           Origin of appended message if mode="append". The user can specify any string.
                 This string will appear as a tag at the start of the appended line in the image
                 history. Default value is imhistory.
message          Message to append if mode="append".

This task provides access to the logtable of an image, where generally history information is
stored. Two operation modes are supported. When mode="list", the history messages are returned
as an array of strings. If verbose=True, this information is also written to the logger. When
mode="append", a specified message (along with its specified origin) are appended to the logtable
and True is returned if successful.

# get image history, print to log window, and store as an array of
# strings in variable x
x = imhistory("my.im", mode="list", verbose=True) 

# append a message
imhistory("my.im", origin="myorigin", message="ETI signal found in this image!")


        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['mode'] = mode
        mytmp['verbose'] = verbose
        mytmp['origin'] = origin
        mytmp['message'] = message
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'imhistory.xml')

        casalog.origin('imhistory')
        if trec.has_key('imhistory') and casac.utils().verify(mytmp, trec['imhistory']) :
	    result = task_imhistory.imhistory(imagename, mode, verbose, origin, message)

	else :
	  result = False
        return result
