#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_plotuv import plotuv
from taskinit import casalog
from taskinit import xmlpath
class plotuv_pg_:
    __name__ = "plotuv"

    def __init__(self) :
       self.__bases__ = (plotuv_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,field=None,antenna=None,spw=None,observation=None,array=None,maxnpts=None,colors=None,symb=None,ncycles=None,figfile=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'plotuv'
        myf['taskname'] = 'plotuv'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['field'] = field = myf['field']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['spw'] = spw = myf['spw']
            myparams['observation'] = observation = myf['observation']
            myparams['array'] = array = myf['array']
            myparams['maxnpts'] = maxnpts = myf['maxnpts']
            myparams['colors'] = colors = myf['colors']
            myparams['symb'] = symb = myf['symb']
            myparams['ncycles'] = ncycles = myf['ncycles']
            myparams['figfile'] = figfile = myf['figfile']

        if type(colors)==str: colors=[colors]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        mytmp['antenna'] = antenna
        mytmp['spw'] = spw
        mytmp['observation'] = observation
        mytmp['array'] = array
        mytmp['maxnpts'] = maxnpts
        mytmp['colors'] = colors
        mytmp['symb'] = symb
        mytmp['ncycles'] = ncycles
        mytmp['figfile'] = figfile
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'plotuv.xml')

        casalog.origin('plotuv')
        if not trec.has_key('plotuv') or not casac.utils().verify(mytmp, trec['plotuv']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: plotuv           #####')
          casalog.post('')
          result = plotuv(vis, field, antenna, spw, observation, array, maxnpts, colors, symb, ncycles, figfile)
          casalog.post('')
          casalog.post('##### End Task: plotuv           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('plotuv', 'plotuv.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'plotuv'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('plotuv', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['vis']  = ''
        a['field']  = ''
        a['antenna']  = ''
        a['spw']  = ''
        a['observation']  = ''
        a['array']  = ''
        a['maxnpts']  = 100000
        a['colors']  = ['r', 'y', 'g', 'b']
        a['symb']  = ','
        a['ncycles']  = 1
        a['figfile']  = ''


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['antenna']  = ''
        a['spw']  = ''
        a['observation']  = ''
        a['array']  = ''
        a['maxnpts']  = 100000
        a['colors']  = ['r', 'y', 'g', 'b']
        a['symb']  = ','
        a['ncycles']  = 1
        a['figfile']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
plotuv_pg = plotuv_pg_()
