#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_sdimaging import sdimaging
from taskinit import casalog
from taskinit import xmlpath
class sdimaging_pg_:
    __name__ = "sdimaging"

    def __init__(self) :
       self.__bases__ = (sdimaging_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, infiles=None,outfile=None,overwrite=None,field=None,spw=None,antenna=None,scan=None,intent=None,mode=None,nchan=None,start=None,width=None,veltype=None,outframe=None,gridfunction=None,convsupport=None,truncate=None,gwidth=None,jwidth=None,imsize=None,cell=None,phasecenter=None,projection=None,ephemsrcname=None,pointingcolumn=None,restfreq=None,stokes=None,minweight=None,brightnessunit=None,clipminmax=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'sdimaging'
        myf['taskname'] = 'sdimaging'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['infiles'] = infiles = myf['infiles']
            myparams['outfile'] = outfile = myf['outfile']
            myparams['overwrite'] = overwrite = myf['overwrite']
            myparams['field'] = field = myf['field']
            myparams['spw'] = spw = myf['spw']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['scan'] = scan = myf['scan']
            myparams['intent'] = intent = myf['intent']
            myparams['mode'] = mode = myf['mode']
            myparams['nchan'] = nchan = myf['nchan']
            myparams['start'] = start = myf['start']
            myparams['width'] = width = myf['width']
            myparams['veltype'] = veltype = myf['veltype']
            myparams['outframe'] = outframe = myf['outframe']
            myparams['gridfunction'] = gridfunction = myf['gridfunction']
            myparams['convsupport'] = convsupport = myf['convsupport']
            myparams['truncate'] = truncate = myf['truncate']
            myparams['gwidth'] = gwidth = myf['gwidth']
            myparams['jwidth'] = jwidth = myf['jwidth']
            myparams['imsize'] = imsize = myf['imsize']
            myparams['cell'] = cell = myf['cell']
            myparams['phasecenter'] = phasecenter = myf['phasecenter']
            myparams['projection'] = projection = myf['projection']
            myparams['ephemsrcname'] = ephemsrcname = myf['ephemsrcname']
            myparams['pointingcolumn'] = pointingcolumn = myf['pointingcolumn']
            myparams['restfreq'] = restfreq = myf['restfreq']
            myparams['stokes'] = stokes = myf['stokes']
            myparams['minweight'] = minweight = myf['minweight']
            myparams['brightnessunit'] = brightnessunit = myf['brightnessunit']
            myparams['clipminmax'] = clipminmax = myf['clipminmax']

        if type(infiles)==str: infiles=[infiles]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infiles'] = infiles
        mytmp['outfile'] = outfile
        mytmp['overwrite'] = overwrite
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['antenna'] = antenna
        mytmp['scan'] = scan
        mytmp['intent'] = intent
        mytmp['mode'] = mode
        mytmp['nchan'] = nchan
        mytmp['start'] = start
        mytmp['width'] = width
        mytmp['veltype'] = veltype
        mytmp['outframe'] = outframe
        mytmp['gridfunction'] = gridfunction
        mytmp['convsupport'] = convsupport
        mytmp['truncate'] = truncate
        mytmp['gwidth'] = gwidth
        mytmp['jwidth'] = jwidth
        mytmp['imsize'] = imsize
        mytmp['cell'] = cell
        mytmp['phasecenter'] = phasecenter
        mytmp['projection'] = projection
        mytmp['ephemsrcname'] = ephemsrcname
        mytmp['pointingcolumn'] = pointingcolumn
        mytmp['restfreq'] = restfreq
        mytmp['stokes'] = stokes
        mytmp['minweight'] = minweight
        mytmp['brightnessunit'] = brightnessunit
        mytmp['clipminmax'] = clipminmax
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'sdimaging.xml')

        casalog.origin('sdimaging')
        if not trec.has_key('sdimaging') or not casac.utils().verify(mytmp, trec['sdimaging']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: sdimaging           #####')
          casalog.post('')
          result = sdimaging(infiles, outfile, overwrite, field, spw, antenna, scan, intent, mode, nchan, start, width, veltype, outframe, gridfunction, convsupport, truncate, gwidth, jwidth, imsize, cell, phasecenter, projection, ephemsrcname, pointingcolumn, restfreq, stokes, minweight, brightnessunit, clipminmax)
          casalog.post('')
          casalog.post('##### End Task: sdimaging           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('sdimaging', 'sdimaging.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'sdimaging'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('sdimaging', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['infiles']  = ['']
        a['outfile']  = ''
        a['overwrite']  = False
        a['field']  = ''
        a['spw']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['intent']  = 'OBSERVE_TARGET#ON_SOURCE'
        a['mode']  = 'channel'
        a['outframe']  = ''
        a['gridfunction']  = 'BOX'
        a['imsize']  = [
            ]
        a['cell']  = ''
        a['phasecenter']  = ''
        a['projection']  = 'SIN'
        a['ephemsrcname']  = ''
        a['pointingcolumn']  = 'direction'
        a['restfreq']  = ''
        a['stokes']  = ''
        a['minweight']  = 0.1
        a['brightnessunit']  = ''
        a['clipminmax']  = False

        a['mode'] = {
                    0:odict([{'value':'channel'}, {'nchan':-1}, {'start':''}, {'width':''}]), 
                    1:odict([{'value':'frequency'}, {'nchan':-1}, {'start':''}, {'width':''}]), 
                    2:odict([{'value':'velocity'}, {'nchan':-1}, {'start':''}, {'width':''}, {'veltype':'radio'}])}
        a['gridfunction'] = {
                    0:{'value':'BOX'}, 
                    1:{'value':'box'}, 
                    2:odict([{'value':'SF'}, {'convsupport':-1}]), 
                    3:odict([{'value':'sf'}, {'convsupport':-1}]), 
                    4:{'value':'PB'}, 
                    5:{'value':'pb'}, 
                    6:odict([{'value':'GAUSS'}, {'truncate':-1}, {'gwidth':-1}]), 
                    7:odict([{'value':'gauss'}, {'truncate':-1}, {'gwidth':-1}]), 
                    8:odict([{'value':'GJINC'}, {'truncate':-1}, {'gwidth':-1}, {'jwidth':-1}]), 
                    9:odict([{'value':'gjinc'}, {'truncate':-1}, {'gwidth':-1}, {'jwidth':-1}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['infiles']  = ['']
        a['outfile']  = ''
        a['overwrite']  = False
        a['field']  = ''
        a['spw']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['intent']  = 'OBSERVE_TARGET#ON_SOURCE'
        a['mode']  = 'channel'
        a['nchan']  = -1
        a['start']  = 0
        a['width']  = 1
        a['veltype']  = 'radio'
        a['outframe']  = ''
        a['gridfunction']  = 'BOX'
        a['convsupport']  = -1
        a['truncate']  = -1
        a['gwidth']  = -1
        a['jwidth']  = -1
        a['imsize']  = [
            ]
        a['cell']  = ''
        a['phasecenter']  = ''
        a['projection']  = 'SIN'
        a['ephemsrcname']  = ''
        a['pointingcolumn']  = 'direction'
        a['restfreq']  = ''
        a['stokes']  = ''
        a['minweight']  = 0.1
        a['brightnessunit']  = ''
        a['clipminmax']  = False

        if a.has_key(paramname) :
	      return a[paramname]
sdimaging_pg = sdimaging_pg_()
