#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
from casa_stack_manip import stack_frame_find
import gc
import numpy
from odict import odict
from task_visstatold import visstatold
from taskinit import casalog
from taskinit import xmlpath
class visstatold_pg_:
    __name__ = "visstatold"

    def __init__(self) :
       self.__bases__ = (visstatold_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,axis=None,datacolumn=None,useflags=None,spw=None,field=None,selectdata=None,antenna=None,uvrange=None,timerange=None,correlation=None,scan=None,array=None,observation=None,):

        myf=stack_frame_find( )
        myf['__last_task'] = 'visstatold'
        myf['taskname'] = 'visstatold'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['axis'] = axis = myf['axis']
            myparams['datacolumn'] = datacolumn = myf['datacolumn']
            myparams['useflags'] = useflags = myf['useflags']
            myparams['spw'] = spw = myf['spw']
            myparams['field'] = field = myf['field']
            myparams['selectdata'] = selectdata = myf['selectdata']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['uvrange'] = uvrange = myf['uvrange']
            myparams['timerange'] = timerange = myf['timerange']
            myparams['correlation'] = correlation = myf['correlation']
            myparams['scan'] = scan = myf['scan']
            myparams['array'] = array = myf['array']
            myparams['observation'] = observation = myf['observation']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['axis'] = axis
        mytmp['datacolumn'] = datacolumn
        mytmp['useflags'] = useflags
        mytmp['spw'] = spw
        mytmp['field'] = field
        mytmp['selectdata'] = selectdata
        mytmp['antenna'] = antenna
        mytmp['uvrange'] = uvrange
        mytmp['timerange'] = timerange
        mytmp['correlation'] = correlation
        mytmp['scan'] = scan
        mytmp['array'] = array
        mytmp['observation'] = observation
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'visstatold.xml')

        casalog.origin('visstatold')
        if not trec.has_key('visstatold') or not casac.utils().verify(mytmp, trec['visstatold']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: visstatold           #####')
          casalog.post('')
          result = visstatold(vis, axis, datacolumn, useflags, spw, field, selectdata, antenna, uvrange, timerange, correlation, scan, array, observation)
          casalog.post('')
          casalog.post('##### End Task: visstatold           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('visstatold', 'visstatold.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'visstatold'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        myf = stack_frame_find( )
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('visstatold', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        myf=stack_frame_find( )
        a = odict()
        a['vis']  = ''
        a['axis']  = 'amplitude'
        a['useflags']  = True
        a['spw']  = ''
        a['field']  = ''
        a['selectdata']  = True

        a['axis'] = {
                    0:odict([{'value':'amp'}, {'datacolumn':'data'}]), 
                    1:odict([{'value':'amplitude'}, {'datacolumn':'data'}]), 
                    2:odict([{'value':'phase'}, {'datacolumn':'data'}]), 
                    3:odict([{'value':'real'}, {'datacolumn':'data'}]), 
                    4:odict([{'value':'imag'}, {'datacolumn':'data'}]), 
                    5:odict([{'value':'imaginary'}, {'datacolumn':'data'}])}
        a['selectdata'] = {
                    0:odict([{'value':True}, {'antenna':''}, {'timerange':''}, {'correlation':''}, {'scan':''}, {'array':''}, {'observation':''}, {'uvrange':''}]), 
                    1:{'value':False}}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      myf=stack_frame_find( )

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['axis']  = 'amplitude'
        a['datacolumn']  = 'data'
        a['useflags']  = True
        a['spw']  = ''
        a['field']  = ''
        a['selectdata']  = True
        a['antenna']  = ''
        a['uvrange']  = ''
        a['timerange']  = ''
        a['correlation']  = ''
        a['scan']  = ''
        a['array']  = ''
        a['observation']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
visstatold_pg = visstatold_pg_()
